<?php
/**
 * @brief		Create Menu Extension : globalnotes
 * @author		<a href='https://www.invisioncommunity.com'>Invision Power Services, Inc.</a>
 * @copyright	(c) Invision Power Services, Inc.
 * @license		https://www.invisioncommunity.com/legal/standards/
 * @package		Invision Community
 * @subpackage	Sticky Notes
 * @since		31 Oct 2017
 */

namespace IPS\stickynotes\extensions\core\CreateMenu;

/* To prevent PHP errors (extending class does not exist) revealing path */
if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * Create Menu Extension: globalnotes
 */
class _globalnotes
{
	/**
	 * Get Items
	 *
	 * @return	array
	 */
	public function getItems()
	{
		if( \IPS\Member::loggedIn()->isAdmin() )
		{
		    return array(
			    'createTab_global_notes' => array(
				    'link' 				=> \IPS\Http\Url::internal( 'app=stickynotes&module=stickynote&controller=globalnotes' ),
				    'title' 			=> 'global_notes',
				    'flashMessage'		=> 'saved',
				    'extraData'			=> array( 'data-ipsDialog' => true )
			    )
		    );
		}

		return array();
	}
}