<?php
/**
 * @brief		Create Menu Extension : sendstickynote
 * @author		<a href='https://www.invisioncommunity.com'>Invision Power Services, Inc.</a>
 * @copyright	(c) Invision Power Services, Inc.
 * @license		https://www.invisioncommunity.com/legal/standards/
 * @package		Invision Community
 * @subpackage	Sticky Notes
 * @since		27 Jul 2017
 */

namespace IPS\stickynotes\extensions\core\CreateMenu;

/* To prevent PHP errors (extending class does not exist) revealing path */
if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * Create Menu Extension: sendstickynote
 */
class _sendstickynote
{
	/**
	 * Get Items
	 *
	 * @return	array
	 */
	public function getItems()
	{
		if( \IPS\Settings::i()->SN_PersonalGroups == 'all' or \IPS\Member::loggedIn()->inGroup( explode(',', \IPS\Settings::i()->SN_PersonalGroups ) ) )
		{
		    return array(
			    'createTab_sticky_note' => array(
				    'link' 				=> \IPS\Http\Url::internal( 'app=stickynotes&module=stickynote&controller=sendnote' ),
				    'title' 			=> 'send_note',
				    'flashMessage'		=> 'sent',
				    'extraData'			=> array( 'data-ipsDialog' => true )
			    )
		    );
		}

		return array();
	}
}