<?php

namespace IPS\stickynotes\extensions\core\GroupForm;

/* To prevent PHP errors (extending class does not exist) revealing path */
if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

class _settings
{
	public function process( &$form, $group )
	{
		if( $group->g_id != \IPS\Settings::i()->guest_group )
		{
			$data = \IPS\stickynotes\Members::getGroupData( $group->g_id );

			$form->addHeader('stickynotes_limit_per_day');
			$form->add( new \IPS\Helpers\Form\YesNo( 'g_sn_require_reply', $data['g_sn_require_reply'], FALSE ) );
			$form->add( new \IPS\Helpers\Form\Number( 'g_sn_perday', $data['g_sn_perday'], FALSE, array( 'unlimited' => -1, 'min' => 0 ), NULL, NULL, NULL, 'g_sn_perday' ) );
		}
	}
	
	public function save( $values, &$group )
	{
		$perDay = -1;
		$reply	= 0;

		if( $group->g_id != \IPS\Settings::i()->guest_group )
		{
			$perDay = $values['g_sn_perday'];
			$reply  = $values['g_sn_require_reply'];

			\IPS\stickynotes\Members::setGroupData( $group->g_id, $perDay, $reply );

			unset( $values['g_sn_perday'] );
			unset( $values['g_sn_require_reply'] );

			\IPS\stickynotes\Members::updateGroupCache();
		}
	}
}