<?php
/**
 * @brief		Admin CP Member Form
 * @author		<a href='https://www.invisioncommunity.com'>Invision Power Services, Inc.</a>
 * @copyright	(c) Invision Power Services, Inc.
 * @license		https://www.invisioncommunity.com/legal/standards/
 * @package		Invision Community
 * @subpackage	Sticky Notes
 * @since		30 Jul 2017
 */

namespace IPS\stickynotes\extensions\core\MemberForm;

/* To prevent PHP errors (extending class does not exist) revealing path */
if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * Admin CP Member Form
 */
class _settings
{
	/**
	 * Process Form
	 *
	 * @param	\IPS\Helpers\Form		$form	The form
	 * @param	\IPS\Member				$member	Existing Member
	 * @return	void
	 */
	public function process( &$form, $member )
	{
		$data = \IPS\stickynotes\Members::getMemberData( $member->member_id );

		$form->add( new \IPS\Helpers\Form\YesNo( 'SN_MemberBlock', $data['blockpersonal'] ) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'SN_MemberBlockReceiving', $data['blockreceiving'] ) );
	}

	/**
	 * Save
	 *
	 * @param	array				$values	Values from form
	 * @param	\IPS\Member			$member	The member
	 * @return	void
	 */
	public function save( $values, &$member )
	{
		\IPS\stickynotes\Members::setMemberData( $member->member_id, $values['SN_MemberBlockReceiving'], $values['SN_MemberBlock'] );
	}
}