//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class stickynotes_hook_MemberSettings extends _HOOK_CLASS_
{
	protected function _snblock()
	{
		try
		{
			try
			{
				$member = \IPS\Member::loggedIn();
		
				try
				{
				    $ignoring = \IPS\Db::i()->select( '*', 'stickynotes_ignore', array( 'member_id=?', $member->member_id ) )->first();
					$list = $ignoring['ignore_list'];
				}
				catch( \UnderflowException $e )
				{
					$ignoring = array();
					$list = array();
				}
		
				$form = new \IPS\Helpers\Form();
		        $form->addTab('StickyNoteTab');
		
				$form->add( new \IPS\Helpers\Form\Member( 'SN_Block_Members', $list ? array_map( array( 'IPS\Member', 'load' ), explode( ",", $list ) ) : NULL, FALSE, array( 'autocomplete' => array( 'minimized' => FALSE ), 'multiple' => NULL ), function( $val )
					{
						if( $val == \IPS\Member::loggedIn() )
						{
							throw new \DomainException('SN_BlockSelf');
						}	
					}
				));
		
				if( $values = $form->values( TRUE ) )
				{
					$ignorelist = $values['SN_Block_Members'];
					$ignore = \is_array( $ignorelist ) ? implode( ",", $ignorelist ) : $ignorelist;
			        $ignore = implode(",", explode("\n", $ignore));	
					
				    if( !$ignoring )
					{
				        \IPS\Db::i()->insert( 'stickynotes_ignore', array( 'member_id' => $member->member_id, 'ignore_list' => $ignore ) );
				    }
					else
					{
						$where = array( 'member_id=?', $member->member_id );
					    \IPS\Db::i()->update( 'stickynotes_ignore', array( 'ignore_list' => $ignore ), $where );
					}
					
					\IPS\Output::i()->redirect(\IPS\Http\Url::internal('app=core&module=system&controller=settings&area=snblock', 'front'), 'saved');			
				}
				
				return \IPS\Theme::i()->getTemplate( 'members', 'stickynotes' )->settings( $form );
			}
			catch ( \Error | \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
}