//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class stickynotes_hook_SendDirectNote extends _HOOK_CLASS_
{
	protected function senddirect()
	{
		try
		{
			try
			{
				$member 	= \IPS\Member::loggedIn();
				$memberData = \IPS\stickynotes\Members::getMemberData( $member->member_id );
		
				$messagesSentToday = \IPS\Db::i()->select( 'COUNT(*) AS count, MAX(time_date) AS max', 'stickynotes_notes', array( 'sender_id=? AND time_date>?', $member->member_id, \IPS\DateTime::create()->sub( new \DateInterval( 'P1D' ) )->getTimeStamp() ) )->first();
				
				if( !$member->member_id )
				{
					\IPS\Output::i()->error( 'no_module_permission_guest', 'StickyNotesGuest/1', 403, '' );
				}
				
				try
				{
				    $blocked = \IPS\Db::i()->select( 'ignore_list', 'stickynotes_ignore', array( 'member_id=?', $this->member->member_id ) )->first();
					
					if( \in_array( $member->member_id, explode( ',', ( $blocked ) ) ) )
				    {
						\IPS\Output::i()->error( 'SN_Been_Blocked', 'StickyNotesBlocked/1', 403, '' );
				    }
				}
				catch( \UnderflowException $e )
				{
				    $blocked = array();
				}
		
				if( \IPS\Settings::i()->SN_PersonalGroups != 'all' AND !$member->inGroup( explode(',', \IPS\Settings::i()->SN_PersonalGroups ) ) )
				{
				    \IPS\Output::i()->error( 'no_permission_personal_member', 'StickyNotesNoPermission/1', 403, '' );
				}
		
				if( !\IPS\Settings::i()->SN_AllowSelfSend )
				{
				    if( $member == $this->member )
				    {
					    \IPS\Output::i()->error( 'SN_SendSelf', 'StickyNotesSendSelf/1', 403, '' );
				    }
				}
		
				if( $memberData['blockpersonal'] == 1 )
				{
					\IPS\Output::i()->error( 'blocked_personal_member', 'StickyNotesBlocked/1', 403, '' );
				}
				
				if( $memberData['blockreceiving'] == 1 )
				{
					\IPS\Output::i()->error( 'SN_BlockReceiving', 'StickyNotesBlockReceiving/1', 403, '' );
				}
		
				$groupData = \IPS\Data\Store::i()->stickynotesGroups[ $member->member_group_id ];
				if( $groupData['g_sn_perday'] !== -1 )
				{
					if( $messagesSentToday['count'] >= $groupData['g_sn_perday'] )
					{
					    $next = \IPS\DateTime::ts( $messagesSentToday['max'] )->add( new \DateInterval( 'P1D' ) );
					    \IPS\Output::i()->error( $member->language()->addToStack( 'max_sticky_notes_day', FALSE, array( 'pluralize' => array( $groupData['g_sn_perday'] ) ) ), 'StickyNotesMaxNotes/2', 429, '', array( 'Retry-After' => $next->format('r') ) );
			        }
				}
		
				$form = new \IPS\Helpers\Form( 'stickynotes', 'SN_send' );
				$form->class = 'ipsForm_vertical ipsForm_fullWidth';
				$form->addTab('StickyNoteTab');
				$form->add( new \IPS\Helpers\Form\Editor( 'StickyNote', NULL, TRUE, array( 'app' => 'stickynotes', 'key' => 'StickyNotes', 'autoSaveKey' => '', 'attachIds' => NULL ) ) );
		/*if( \IPS\Settings::i()->SN_PersonalAnon )
		{
			$form->add( new \IPS\Helpers\Form\YesNo( 'SN_PersonalUseAnon', FALSE, FALSE, array( 'label' => \IPS\Member::loggedIn()->language()->addToStack( 'SN_PersonalUseAnon_label' ) ) ) );
		}*/
		
				if( \IPS\Settings::i()->SN_PersonalAnon )
				{
					if( $groupData['g_sn_require_reply'] )
					{
						$form->add( new \IPS\Helpers\Form\YesNo( 'SN_PersonalUseAnon', FALSE, FALSE, array( 'togglesOff' => array( 'SN_PersonalRequireReply' ), 'label' => \IPS\Member::loggedIn()->language()->addToStack( 'SN_PersonalUseAnon_label' ) ) ) );
						$form->add( new \IPS\Helpers\Form\YesNo( 'SN_PersonalRequireReply', FALSE, FALSE, array( 'label' => \IPS\Member::loggedIn()->language()->addToStack( 'SN_PersonalRequireReply_label' ) ), NULL, NULL, NULL, 'SN_PersonalRequireReply' ) );
					}
					else
					{
						$form->add( new \IPS\Helpers\Form\YesNo( 'SN_PersonalUseAnon', FALSE, FALSE, array( 'label' => \IPS\Member::loggedIn()->language()->addToStack( 'SN_PersonalUseAnon_label' ) ) ) );	
					}
				}
		
				if( !\IPS\Settings::i()->SN_PersonalAnon AND $groupData['g_sn_require_reply'] )
				{
					$form->add( new \IPS\Helpers\Form\YesNo( 'SN_PersonalRequireReply', FALSE, FALSE, array( 'label' => \IPS\Member::loggedIn()->language()->addToStack( 'SN_PersonalRequireReply_label' ) ), NULL, NULL, NULL, 'SN_PersonalRequireReply' ) );
				}
		
				if( $values = $form->values() )
				{
					$sender_id = $member->member_id;
					$group_id = $member->member_group_id;
					$member_id = $this->member->member_id;
					$stickyNote = new \IPS\stickynotes\StickyNotes;
					if( \IPS\Settings::i()->SN_PersonalAnon AND !$values['SN_PersonalUseAnon'] )
					{
						$stickyNote->note = $values['StickyNote'];
						$stickyNote->sender_id = $sender_id;
						$stickyNote->member_id = $member_id;
						$stickyNote->time_date = time();
						$stickyNote->group_id = $group_id;
						$stickyNote->anonymous = NULL;
						$stickyNote->require_reply = isset( $values['SN_PersonalRequireReply'] ) ? $values['SN_PersonalRequireReply'] : 0;
						$stickyNote->save();
					}
					else if( \IPS\Settings::i()->SN_PersonalAnon AND $values['SN_PersonalUseAnon'] )
					{
						$stickyNote->note = $values['StickyNote'];
						$stickyNote->sender_id = $sender_id;
						$stickyNote->member_id = $member_id;
						$stickyNote->time_date = time();
						$stickyNote->group_id = $group_id;
						$stickyNote->anonymous = 1;
						$stickyNote->require_reply = isset( $values['SN_PersonalRequireReply'] ) ? $values['SN_PersonalRequireReply'] : 0;
						$stickyNote->save();
					}
					else 
					{
						$stickyNote->note = $values['StickyNote'];
						$stickyNote->sender_id = $sender_id;
						$stickyNote->member_id = $member_id;
						$stickyNote->time_date = time();
						$stickyNote->group_id = $group_id;
						$stickyNote->anonymous = NULL;
						$stickyNote->require_reply = isset( $values['SN_PersonalRequireReply'] ) ? $values['SN_PersonalRequireReply'] : 0;
						$stickyNote->save();
					}
		
					\IPS\File::claimAttachments( '', $stickyNote->id, $member_id, 'stickynotes' );
					\IPS\Output::i()->redirect( \IPS\Request::i()->referrer() ?: \IPS\Http\Url::internal( '' ), 'sticky_note_sent' );
				}
		
				\IPS\Session::i()->setLocation( $member->url(), array(), 'loc_sending_note', array( $member->name => FALSE ) );
				\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack( 'send_note', FALSE, array( 'sprintf' => array( $member->name ) ) );
				\IPS\Output::i()->breadcrumb[] = array( NULL, \IPS\Member::loggedIn()->language()->addToStack( 'sending_note', FALSE, array( 'sprintf' => array( $member->name ) ) ) );
				\IPS\Output::i()->output = \IPS\Theme::i()->getTemplate('form', 'stickynotes')->form( $form );
			}
			catch ( \Error | \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
}