<?php


namespace IPS\stickynotes\modules\admin\personalstickynotes;

/* To prevent PHP errors (extending class does not exist) revealing path */
if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * massdelete
 */
class _massdelete extends \IPS\Dispatcher\Controller
{
	public static $csrfProtected = TRUE;

	protected function manage()
	{
		$form = new \IPS\Helpers\Form;
        $form->addHeader('Delete All Sticky Notes');
		$form->add( new \IPS\Helpers\Form\Select( 'SN_MassDelete', NULL, FALSE, array( 'options' => array_merge( array( 'none' => 'None', 'all' => 'All', 'read' => 'Read', 'unread' => 'Unread' ) ) ) ) );
		$form->addHeader('Delete Members Sticky Notes');
		$form->add( new \IPS\Helpers\Form\Member( 'SN_MassDeleteMembers', NULL ? array_map( array( 'IPS\Member', 'load' ), explode( "\n", NULL ) ) : NULL, FALSE, array( 'max' => 1 ), NULL, NULL, NULL, 'SN_MassDeleteMembers' ) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'SN_SelectMassDeleteGroups', NULL, FALSE, array('togglesOn' => array( 'SN_MassDeleteGroups' ), 'togglesOff' => array( 'SN_MassDeleteMembers' ) ) ) );
		$form->add( new \IPS\Helpers\Form\Select( 'SN_MassDeleteGroups', NULL, FALSE, array( 'options'	=> \IPS\Member\Group::groups( TRUE, FALSE ), 'parse' => 'normal' ), NULL, NULL, NULL, 'SN_MassDeleteGroups' ) );

		if( $values = $form->values() )
        {
	        $form->saveAsSettings();

			if( $values['SN_MassDelete'] == 'read' )
			{
				\IPS\Db::i()->delete( 'stickynotes_notes', array( 'dismissed=?', 1 ) );
				\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=stickynotes&module=personalstickynotes&controller=massdelete' ), 'All read sticky notes have been deleted' );
	        }

			if( $values['SN_MassDelete'] == 'unread' )
			{
				\IPS\Db::i()->delete( 'stickynotes_notes', array( 'dismissed=?', 0 ) );
				\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=stickynotes&module=personalstickynotes&controller=massdelete' ), 'All unread sticky notes have been deleted' );
	        }

			if( $values['SN_MassDelete'] == 'all' )
			{
				\IPS\Db::i()->delete( 'stickynotes_notes', 'id' );
				\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=stickynotes&module=personalstickynotes&controller=massdelete' ), 'All sticky notes have been deleted' );
	        }

			if( $values['SN_MassDeleteMembers']  )
			{
				$member_id = $values['SN_MassDeleteMembers']->member_id;
				\IPS\Db::i()->delete( 'stickynotes_notes', array( 'member_id=?', $member_id ) );
				\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=stickynotes&module=personalstickynotes&controller=massdelete' ), 'All selected members personal sticky notes have been deleted' );
	        }

			if( $values['SN_SelectMassDeleteGroups'] == TRUE  )
			{
				$group_id = $values['SN_MassDeleteGroups'];
				\IPS\Db::i()->delete( 'stickynotes_notes', array( 'group_id=?', $group_id ) );
				\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=stickynotes&module=personalstickynotes&controller=massdelete' ), 'deleted' );
	        }

			\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=stickynotes&module=personalstickynotes&controller=massdelete' ), 'Nothing has been done, Select a option to delete some sticky notes from the database' );

			return TRUE;
        }

		\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack( 'SN_Mass_Delete' );
		\IPS\Output::i()->output = $form;
	}
}