<?php


namespace IPS\stickynotes\modules\admin\personalstickynotes;

/* To prevent PHP errors (extending class does not exist) revealing path */
if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * personalstickynotes
 */
class _personalstickynotes extends \IPS\Dispatcher\Controller
{
	public static $csrfProtected = TRUE;

	/**
	 * Execute
	 *
	 * @return	void
	 */
	public function execute()
	{
		parent::execute();
	}

	/**
	 * ...
	 *
	 * @return	void
	 */
	protected function manage()
	{
		$form = new \IPS\Helpers\Form;
		$form->addTab('PersonalStickyNoteTab');
        $form->add( new \IPS\Helpers\Form\Select( 'SN_PersonalGroups', ( \IPS\Settings::i()->SN_PersonalGroups == 'all' ) ? 'all' : explode( ',', \IPS\Settings::i()->SN_PersonalGroups ), FALSE, array( 'options' => \IPS\Member\Group::groups(TRUE, FALSE), 'parse' => 'normal', 'multiple' => true, 'unlimited' => 'all', 'unlimitedLang' => 'all_groups' ), NULL, NULL, NULL, 'SN_PersonalGroups' ) );
        $form->add( new \IPS\Helpers\Form\Select( 'SN_PerPosition', \IPS\Settings::i()->SN_PerPosition, FALSE, array( 'app' => 'core', 'key' => 'Admin', 'autoSaveKey' => 'SN_PerPosition', 'options' => array( 'tl' => 'Top Left', 'tr' => 'Top Right', 'tc' => 'Top Center', 'bl' => 'Bottom Left', 'br' => 'Bottom Right', 'bc' => 'Bottom Center', 'ml' => 'Middle Left', 'mr' => 'Middle Right', 'mc' => 'Middle Center' ), 'multiple' => FALSE ) , NULL, NULL, NULL, 'SN_PerPosition') );
		$form->add( new \IPS\Helpers\Form\Color( 'SN_PersonalColour', \IPS\Settings::i()->SN_PersonalColour, FALSE, array( 'app' => 'core', 'key' => 'Admin', 'autoSaveKey' => 'SN_PersonalColour' ), NULL, NULL, NULL, 'SN_PersonalColour' ) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'SN_PersonalAnon', \IPS\Settings::i()->SN_PersonalAnon, FALSE, array( ) ) );
        $form->add( new \IPS\Helpers\Form\YesNo( 'SN_AllowSelfSend', \IPS\Settings::i()->SN_AllowSelfSend, FALSE, array( ) ) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'SN_Show_Send_Forums', \IPS\Settings::i()->SN_Show_Send_Forums, FALSE, array( ) ) );
        $form->add( new \IPS\Helpers\Form\YesNo( 'SN_MultiDimiss', \IPS\Settings::i()->SN_MultiDimiss, FALSE, array(), NULL, NULL, NULL, 'SN_MultiDimiss' ) );

		if( $values = $form->values() )
        {
	        $form->saveAsSettings();
			\IPS\Theme::deleteCompiledCss( );
	        \IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=stickynotes&module=personalstickynotes&controller=personalstickynotes' ), 'saved' );
	        return TRUE;
        }

		\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack( 'SN_Personal_Sticky_notes' );
		\IPS\Output::i()->output = $form;
	}
}