<?php


namespace IPS\stickynotes\modules\admin\stickynotes;

/* To prevent PHP errors (extending class does not exist) revealing path */
if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * settings
 */
class _settings extends \IPS\Dispatcher\Controller
{
	public static $csrfProtected = TRUE;

	protected function manage()
	{
		$form = new \IPS\Helpers\Form;

		$form->addHeader('Style');
		$form->add( new \IPS\Helpers\Form\Select( 'SN_Style', \IPS\Settings::i()->SN_Style, FALSE, array( 'app' => 'core', 'key' => 'Admin', 'autoSaveKey' => 'SN_Style', 'options' => array( 0 => 'Pinned', 1 => 'Taped' ), 'multiple' => FALSE ) , NULL, NULL, NULL, 'SN_Style') );
		$form->add( new \IPS\Helpers\Form\YesNo( 'SN_AllowDrag', \IPS\Settings::i()->SN_AllowDrag, FALSE, array( 'app' => 'core', 'key' => 'Admin', 'autoSaveKey' => 'SN_AllowDrag' ), NULL, NULL, NULL, 'SN_AllowDrag') );
		$form->addHeader('Devices');
		$form->add( new \IPS\Helpers\Form\Select( 'SN_Devices', \IPS\Settings::i()->SN_Devices, FALSE, array( 'app' => 'core', 'key' => 'Admin', 'autoSaveKey' => 'SN_Devices',
			'options' => array(
				'SN_Null' => 'Show On All',
				'ipsResponsive_hidePhone' => 'Hide On Mobile',
				'ipsResponsive_hideTablet' => 'Hide On Tablets',
				'ipsResponsive_hidePhone ipsResponsive_hideTablet' => 'Hide On Both',),
	    	'toggles' => array(
				'SN_Null' => array( 'SN_Mobiles' ),
				'ipsResponsive_hidePhone' => array(),
				'ipsResponsive_hideTablet' => array( 'SN_Mobiles' ),
				'ipsResponsive_hidePhone ipsResponsive_hideTablet' => array(),
		) ), NULL, NULL, NULL, 'SN_Devices'));
		$form->add( new \IPS\Helpers\Form\Number( 'SN_Mobiles', \IPS\Settings::i()->SN_Mobiles, FALSE, array( 'min' => 4, 'max' => 9 ), NULL, '0.', '%', 'SN_Mobiles' ));
		$form->addHeader( 'Z-Index' );
		$form->add( new \IPS\Helpers\Form\Number( 'SN_zindex', \IPS\Settings::i()->SN_zindex, FALSE, array( 'max' => 9000, 'min' => 4000 ), NULL, NULL, NULL, 'SN_zindex' ) );

		if( $values = $form->values() )
        {
	        $form->saveAsSettings();
	        \IPS\Theme::deleteCompiledCss( );
			\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=stickynotes&module=stickynotes&controller=settings' ), 'saved' );
	        return TRUE;
        }
		
		/*if( !isset( \IPS\Data\Store::i()->sticky_notes_cr ) )
		{
			\IPS\Output::i()->sidebar['actions']['fm_copyright_removal'] = array(
				'icon'		=> 'flash',
				'title'		=> 'Copyright Removal',
				'link'		=> \IPS\Http\Url::internal( 'app=stickynotes&module=stickynotes&controller=settings&do=fm' ),
				'data'		=> array( )
			);
		}*/

		\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack( 'settings' );
		\IPS\Output::i()->output = $form;
	}
	
	protected function fm()
	{
/*		$emailRequest = \IPS\Request::i()->fm_copyright_removal_email ?: NULL;
		$refreshRequest = \IPS\Request::i()->fm_copyright_refresh ?: NULL;
		$extra = array();
		$extra['num'] = 64;
		$extra['que'] = 22;
		$extra['uni'] = 51;
		$jsonExtra = json_encode( $extra, true );
		
		\IPS\Member::loggedIn()->language()->words[ 'fm_copyright_removal_key' ] = 'License Key';
		\IPS\Member::loggedIn()->language()->words[ 'fm_copyright_removal_key_desc' ] = 'Dont Have A Key? Purchase One <a target="_blank" rel="nofollow" href="https://flashmodding.com/index.php?/store/product/51-sticky-notes-copyright-removal/">Here</a> ( Opens In New Window )';
		\IPS\Member::loggedIn()->language()->words[ 'fm_copyright_removal_email' ] = 'Identifier';
		\IPS\Member::loggedIn()->language()->words[ 'fm_copyright_removal_email_desc' ] = 'This is the email address you use for the account you purchased the copyright removal from';
		\IPS\Member::loggedIn()->language()->words[ 'fm_copyright_refresh' ] = 'Refresh Key';
		\IPS\Member::loggedIn()->language()->words[ 'fm_No' ] = 'No';
		\IPS\Member::loggedIn()->language()->words[ 'fm_No_desc' ] = 'I am adding the key for the first time';
		\IPS\Member::loggedIn()->language()->words[ 'fm_Yes' ] = 'Yes';
		\IPS\Member::loggedIn()->language()->words[ 'fm_Yes_desc' ] = 'Yes I need to refesh the key';
		
		$form = new \IPS\Helpers\Form;
		$form->class = 'ipsPad ipsBox ipsForm_fullWidth';
		$form->add( new \IPS\Helpers\Form\Text( 'fm_copyright_removal_key', NULL, TRUE, array( ), function( $val ) use ( $emailRequest, $refreshRequest, $jsonExtra )
		{
			if( $refreshRequest == 0 )
			{
				$url = 'https://flashmodding.com/applications/nexus/interface/licenses/branding.php?activate&key='.$val.'&identifier='.$emailRequest.'&extra='.$jsonExtra.'';
			}
			else
			{
				$url = 'https://flashmodding.com/applications/nexus/interface/licenses/branding.php?check&key='.$val.'&identifier='.$emailRequest.'&usage_id=1';
			}
			$response = \IPS\Http\Url::external( $url )->request()->get();
			$responseData = $response->decodeJson();
			
			if( $response->httpResponseCode != 200 )
			{
				throw new \DomainException( $responseData['errorCode'] );
			}			
		}
		) );
		$form->add( new \IPS\Helpers\Form\Email( "fm_copyright_removal_email", NULL, TRUE, array( ) ) );
		$form->add( new \IPS\Helpers\Form\Radio( "fm_copyright_refresh", NULL, FALSE, array( 'options' => array( 0 => 'fm_No', 1 => 'fm_Yes' ) ) ) );
		
		if( $values = $form->values(TRUE) )
		{
			unset( \IPS\Data\Store::i()->sticky_notes_cr );
			\IPS\Data\Store::i()->sticky_notes_cr = $values['fm_copyright_removal_key'];
			
			if( $values['fm_copyright_refresh'] == 0 )
			{
				\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=stickynotes&module=stickynotes&controller=settings' ), 'License Key Accepted' );
			}
			else
			{
				\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=stickynotes&module=stickynotes&controller=settings' ), 'License Key Refreshed' );
			}
		}
		
		\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack( 'Copyright Removal' );
		\IPS\Output::i()->output = $form;*/
	}
}