<?php


namespace IPS\stickynotes\modules\front\dismiss;

/* To prevent PHP errors (extending class does not exist) revealing path */
if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * stickynotes
 */
class _stickynotes extends \IPS\Dispatcher\Controller
{
	/**
	 * Execute
	 *
	 * @return	void
	 */
	public function execute()
	{
		
		parent::execute();
	}

	/**
	 * ...
	 *
	 * @return	void
	 */
	protected function manage()
	{
		// This is the default method if no 'do' parameter is specified
	}
	
	public function dismissPerStickyNote()
    {
	  \IPS\Session::i()->csrfCheck();
		
	  try
	  {
		if( \IPS\Member::loggedIn()->member_id )
		{
            $id  = \intval( \IPS\Request::i()->id );
        	$dismissed = \IPS\stickynotes\StickyNotes::load( $id );
			$dismissed->dismissed = 1;
			$dismissed->save();
		}
		else
		{
			\IPS\Request::i()->setCookie( 'StickyNote_dismissed', TRUE );
		}
		
		if( \IPS\Request::i()->isAjax() )
		{
			\IPS\Output::i()->sendOutput( NULL, 200 );
		}
		else
		{
			\IPS\Output::i()->redirect( \IPS\Request::i()->referrer() ?: \IPS\Http\Url::internal( '' ) );
		}
	  }
	  catch( \Exception $e )
	  {
		\IPS\Output::i()->error( 'stickynote_dismiss_error', 'StickyNotesDismiss/8', 403, '' );
	  }
    }
	
	
	
	public function dismissStickyNote()
    {
	  \IPS\Session::i()->csrfCheck();
	  $id  = \intval( \IPS\Request::i()->id );
	  
	  try
	  {
		if( \IPS\Member::loggedIn()->member_id )
		{
			$dismissed = new \IPS\stickynotes\Dismissed;
			$dismissed->note_id = $id;
			$dismissed->member_id = \IPS\Member::loggedIn()->member_id;
			$dismissed->dismissed = 1;
			$dismissed->save();
		}
		else
		{
			\IPS\Request::i()->setCookie( "SN_dismissed$id", TRUE );
		}
		
		if( \IPS\Request::i()->isAjax() )
		{
			\IPS\Output::i()->sendOutput( NULL, 200 );
		}
		else
		{
			\IPS\Output::i()->redirect( \IPS\Request::i()->referrer() ?: \IPS\Http\Url::internal( '' ) );
		}
	  }
	  catch( \Exception $e )
	  {
		\IPS\Output::i()->error( 'stickynote_dismiss_error', 'StickyNotesDismiss/8', 403, '' );
	  }
	}
	
	public function dismissAll()
    {		
	  try
	  {
		$member = \IPS\Member::loggedIn()->member_id;
		$where = array( 'member_id=? AND dismissed=?', $member, 0 );
		\IPS\Db::i()->update( 'stickynotes_notes', array( 'dismissed' => 1 ), $where );
		\IPS\Output::i()->redirect( \IPS\Request::i()->referrer() ?: \IPS\Http\Url::internal( '' ), 'All sticky notes have been dismissed' );
		
	  }
	  catch( \Exception $e )
	  {
		\IPS\Output::i()->error( 'stickynote_dismiss_error', 'StickyNotesDismiss/8', 403, '' );
	  }
    }
}