<?php


namespace IPS\stickynotes\modules\front\stickynote;

/* To prevent PHP errors (extending class does not exist) revealing path */
if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * globalnotes
 */
class _globalnotes extends \IPS\Dispatcher\Controller
{
	/**
	 * Execute
	 *
	 * @return	void
	 */
	public function execute()
	{
		
		parent::execute();
	}

	/**
	 * ...
	 *
	 * @return	void
	 */
	protected function manage()
	{
		$id = \IPS\Member::loggedIn()->member_id;
		$member = \IPS\Member::load( $id );
		
		if( ! \IPS\Member::loggedIn()->isAdmin() )
	    {
		    \IPS\Output::i()->error( 'no_permission_global_front', 'StickyNotesAdminNotes/1', 403, '' );
	    }
		
		$form = new \IPS\Helpers\Form;
		$form->add( new \IPS\Helpers\Form\Text( 'SN_Title', NULL, TRUE, array( ) ) );
        $tags = \IPS\stickynotes\GlobalNote::getTags();
        $form->add( new \IPS\Helpers\Form\Editor( 'SN_Content', NULL, TRUE, array( 'app' => 'stickynotes', 'key' => 'StickyNotes', 'autoSaveKey' => '', 'attachIds' => NULL, 'tags' => $tags ), NULL, NULL, NULL, 'SN_Content' ) );
        $form->add( new \IPS\Helpers\Form\Color( 'SN_Colour', "EAE672", TRUE, array( 'app' => 'core', 'key' => 'Admin', 'autoSaveKey' => 'SN_Colour' ), NULL, NULL, NULL, 'SN_Colour' ) );
        $form->add( new \IPS\Helpers\Form\Select( 'SN_Position', 0, TRUE, array( 'app' => 'core', 'key' => 'Admin', 'autoSaveKey' => 'SN_Position', 'options' => array( 0 => 'Top Left', 1 => 'Top Right', 2 => 'Top Center', 3 => 'Bottom Left', 4 => 'Bottom Right', 5 => 'Bottom Center', 6 => 'Middle Left', 7 => 'Middle Right', 8 => 'Middle Center' ), 'multiple' => FALSE ) , NULL, NULL, NULL, 'SN_Position') );
        $form->add( new \IPS\Helpers\Form\Member( 'SN_Signature', $member->member_id ? array_map( array( 'IPS\Member', 'load' ), explode( "\n", $member->member_id ) ) : NULL, FALSE, array( 'max' => 1 ), NULL, NULL, NULL, 'SN_Signature' ) );
        $form->add( new \IPS\Helpers\Form\Select( 'SN_Groups', ( NULL == 'all' ) ? 'all' : explode( ',', NULL ), TRUE, array( 'options' => \IPS\Member\Group::groups(), 'parse' => 'normal', 'multiple' => true, 'unlimited' => 'all', 'unlimitedLang' => 'all_groups' ), NULL, NULL, NULL, 'SN_Groups' ) );
        $form->add( new \IPS\Helpers\Form\Date( 'SN_ShowUntil', -1, TRUE, array( 'time' => TRUE, 'unlimited' => -1, 'unlimitedLang' => 'SN_UntilTheyDismiss' ), NULL, \IPS\Member::loggedIn()->language()->addToStack('until'), NULL, 'SN_ShowUntil' ) );
		$sql = \IPS\Db::i()->select( '*', 'core_applications', array( 'app_protected=? AND app_enabled=?', 0, 1 ) );
		foreach( $sql as $k => $v )
        {
			$appName = \IPS\Application::load( $v[ 'app_id' ], 'app_id' )->_title;
            $f[ $v[ 'app_directory' ] ] = $appName;
        }
		$form->add( new \IPS\Helpers\Form\Select( 'SN_Where', 'all', TRUE, array( 'options' => $f, 'unlimited' => 'all', 'unlimitedLang' => "Everywhere" ), NULL, NULL, NULL, 'SN_Where' ) );

		if( $values = $form->values(TRUE) )
	    {
			$GlobalStickyNote = new \IPS\stickynotes\GlobalNote;
			$GlobalStickyNote->level = 0;
			$GlobalStickyNote->active = 1;
			$GlobalStickyNote->title = $values['SN_Title'];
			$GlobalStickyNote->note = $values['SN_Content'];
			$GlobalStickyNote->colour = $values['SN_Colour'];
			$GlobalStickyNote->position = $values['SN_Position'];
			$GlobalStickyNote->signature = $values['SN_Signature'];
			$GlobalStickyNote->show_to = $values['SN_Groups'];
			$GlobalStickyNote->show_until = $values['SN_ShowUntil'];
			$GlobalStickyNote->where = $values['SN_Where'];
			$GlobalStickyNote->save();
			\IPS\File::claimAttachments( '', $GlobalStickyNote->id, $member->member_id, 'globalstickynotes' );
			\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=stickynotes&module=stickynote&controller=globalnotes' ), 'saved' );
		}

		\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack( 'SN_Sticky_Notes' );
		\IPS\Output::i()->output = $form->customTemplate( array( \IPS\Theme::i()->getTemplate( 'forms', 'core' ), 'popupTemplate' ) );
	}
}