<?php

namespace IPS\stickynotes\setup\upg_23002;

/* To prevent PHP errors (extending class does not exist) revealing path */
if( !\defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * 2.3.2 Upgrade Code
 */
class _Upgrade
{
	public function step1()
	{
		foreach( \IPS\Member\Group::groups() as $group )
		{
			\IPS\stickynotes\Members::setGroupData( $group->g_id, $group->g_sn_perday );
		}

		return TRUE;
	}

	public function step1CustomTitle()
	{
		return "Moving groups data for a proper table";
	}

	public function step2()
	{
		try
		{
			\IPS\Db::i()->dropColumn( 'core_groups', 'g_sn_perday' );
		}
		catch( \IPS\Db\Exception $e )
		{
			if( $e->getCode() <> 1091 )
			{
				throw $e;
			}
		}

		return TRUE;
	}

	public function step2CustomTitle()
	{
		return "Dropping columns from core tables";
	}

	public function step3()
	{
		if( \IPS\Db::i()->checkForColumn( 'core_members', 'blockpersonal' ) )
		{
			\IPS\Task::queue( 'stickynotes', 'SNotesMembersData', array(), 1 );
		}
		else
		{
			\IPS\Task::queue( 'stickynotes', 'SNotesMembersDataOneColumn', array(), 1 );
		}

		return TRUE;
	}

	public function step3CustomTitle()
	{
		return "Updating member's preferences";
	}
}