<?php

namespace IPS\stickynotes;

if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
    header( ( isset( $_SERVER[ 'SERVER_PROTOCOL' ] ) ? $_SERVER[ 'SERVER_PROTOCOL' ] :
            'HTTP/1.0' ) . ' 403 Forbidden' );
    exit;
}

class _Ignore extends \IPS\Patterns\ActiveRecord
{
    
    /**
     * @brief    [ActiveRecord] Multiton Store
     */
    protected static $multitons;

    /**
     * @brief    [ActiveRecord] Database table
     */
    public static $databaseTable = 'stickynotes_ignore';

    /**
     * @brief    [ActiveRecord] Database Prefix
     */
    public static $databasePrefix = '';

    /**
     * @brief    [ActiveRecord] ID Database Column
     */
    public static $databaseColumnId = 'id';

    /**
     * @brief    [ActiveRecord] Database ID Fields
     */
    protected static $databaseIdFields = [ 'id', 'member_id', 'ignore_list' ];

	public static function ignore()
	{
		$member = \IPS\Member::loggedIn()->member_id;
		
		try
		{
		    $ignore = \IPS\Db::i()->select( 'ignore_list', 'stickynotes_ignore', array( 'member_id=?', $member ) )->first();
		}
		catch( \UnderflowException $e )
		{
			$ignore = array();
		}
		
		return $ignore;
	}
}