<?php

namespace IPS\stickynotes;

/* To prevent PHP errors (extending class does not exist) revealing path */
if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

class _Members
{
	public static function getMemberData( $memberId )
	{
		try
		{
			$data = \IPS\Db::i()->select( 'blockreceiving, blockpersonal', 'stickynotes_members', array( 'mid=?', $memberId ) )->first();
		}
		catch( \UnderflowException $e )
		{
			$data = array( 'blockreceiving' => 0, 'blockpersonal' => 0 );
		}

		return $data;
	}

	public static function setMemberData( $memberId, $blockreceiving, $blockpersonal )
	{
		\IPS\Db::i()->replace( 'stickynotes_members',
			array(
				'mid'				=> $memberId,
				'blockreceiving'	=> $blockreceiving,
				'blockpersonal'		=> $blockpersonal
			)
		);
	}

	public static function getGroupData( $groupId )
	{
		if( isset( \IPS\Data\Store::i()->stickynotesGroups ) )
		{
			$data = \IPS\Data\Store::i()->stickynotesGroups[ $groupId ];
		}
		else
		{
			$data = array( 'g_sn_perday' => "-1", 'g_sn_require_reply' => 0 );
		}

		return $data;
	}

	public static function setGroupData( $groupId, $perday, $reply )
	{
		\IPS\Db::i()->replace( 'stickynotes_groups',
			array(
				'g_sn_id'			 => $groupId,
				'g_sn_perday'		 => $perday,
				'g_sn_require_reply' => $reply
			)
		);

		static::updateGroupCache();
	}

	public static function updateGroupCache()
	{
		if( isset( \IPS\Data\Store::i()->stickynotesGroups ) )
		{
			unset( \IPS\Data\Store::i()->stickynotesGroups );
		}

		$groups = iterator_to_array( \IPS\Db::i()->select( '*', 'stickynotes_groups' )->setKeyField( 'g_sn_id' ) );
		\IPS\Data\Store::i()->stickynotesGroups = $groups;
	}

	public function dummy()
	{
		//nothing here
	}
}