<?php

namespace IPS\stickynotes;

if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
    header( ( isset( $_SERVER[ 'SERVER_PROTOCOL' ] ) ? $_SERVER[ 'SERVER_PROTOCOL' ] :
            'HTTP/1.0' ) . ' 403 Forbidden' );
    exit;
}

class _StickyNotes extends \IPS\Patterns\ActiveRecord
{
    protected static $multitons;
    public static $databaseTable = 'stickynotes_notes';
    public static $databasePrefix = '';
    public static $databaseColumnId = 'id';
    protected static $databaseIdFields = [ 'id', 'sender_id', 'member_id' ];

	public static function getdb()
	{
		$member = \IPS\Member::loggedIn()->member_id;
		$db = \IPS\Db::i()->select( 'id', 'stickynotes_notes', array( 'member_id=? AND dismissed=?', $member, 0 ) )->first();

		return $db;
	}
	
	public static function personalNotes()
	{
		$member = \IPS\Member::loggedIn()->member_id;

		return new \IPS\Patterns\ActiveRecordIterator( \IPS\Db::i()->select( '*', 'stickynotes_notes', array( 'dismissed=? AND member_id=?', 0, $member ), 'time_date ASC' ), '\IPS\stickyNotes\StickyNotes' );
	}

	public static function hasnote()
	{
		$member = \IPS\Member::loggedIn()->member_id;
		$hasnote = \IPS\Db::i()->select( 'COUNT(*)', 'stickynotes_notes', array( 'member_id=? AND dismissed=?', $member, 0 ) )->first();
		
		return $hasnote;
	}	

	public static function senderid()
	{
		$member = \IPS\Member::loggedIn()->member_id;
		$db = \IPS\Db::i()->select( '*', 'stickynotes_notes', array( 'member_id=? AND dismissed=?', $member, 0 ) )->first();
		$SigID = $db['sender_id'];
        $SigName = \IPS\Member::load( $SigID );

		return $SigName;
	}

	public static function canSendNote( $member )
	{
		$canSend = FALSE;

		if( $member->member_id != \IPS\Member::loggedIn()->member_id )
		{
			$canSend = TRUE;
		}

		if( \IPS\Settings::i()->SN_AllowSelfSend AND $member->member_id == \IPS\Member::loggedIn()->member_id )
		{
			$canSend = TRUE;
		}

		if( !$member->member_id OR !\IPS\Member::loggedIn()->member_id )
		{
			$canSend = FALSE;
		}

		if( $canSend AND ( \IPS\Settings::i()->SN_PersonalGroups == 'all' OR \IPS\Member::loggedIn()->inGroup( explode( ',', \IPS\Settings::i()->SN_PersonalGroups ) ) ) )
		{
			return TRUE;
		}

		return FALSE;
	}

	public static function canDismissAll()
	{
		$data = \IPS\Db::i()->select( 'COUNT(*)', 'stickynotes_notes', array( 'member_id=? AND dismissed=? AND require_reply=?', \IPS\Member::loggedIn()->member_id, 0, 1 ) )->first();

		if( $data )
		{
			return FALSE;
		}

		return TRUE;
	}
}